# map enums, unions and structs
# input:
#  TREE: c99tree AST
#  prnt: file name where results should be printed immediately or ""
# output (optional):
#   DATA[idx, *]   properties of names, each (idx is a full name)
#   NAMES[idx]     a list of all names found (idx is a full name, value is the uid)
function map_data(TREE, prnt,    DATA, NAMES         ,enum_r,n,i,nm,ENUM_SEEN,UNISTR_SEEN,unistr_r,map,ty,idx,sn,sc) {
	gtx_init(TREE)

	enum_r = gtx_find_results(TREE, "enum")
	for(n = 0; n < num_children(TREE, enum_r); n++) {
		delete MAP
		i=gtx_get_map(TREE, MAP, enum_r, n)
		enum_uid = MAP["e"]
		nm = safe_name(TREE, i)
		if (!(enum_uid in ENUM_SEEN)) {
			ENUM_SEEN[enum_uid]=1
			sc = scope_str(TREE, enum_uid)
			sn = safe_name(TREE, enum_uid)
			if (prnt)
				print "enum", enum_uid, sc, sn > prnt
			if (sc != "")
				idx=sc "." sn
			else
				idx = sn
			DATA[idx, "name"]  = sn
			DATA[idx, "scope"] = sc
			DATA[idx, "uid"] = enum_uid
			DATA[idx, "type"] = "enum"
			NAMES[idx] = enum_uid
		}
		sc = scope_str(TREE, i)
		sn = safe_name(TREE, enum_uid)
		if (prnt)
			print "enum-member", i,  sc, nm > prnt

		idx=sc "." nm
		DATA[idx, "name"]  = nm
		DATA[idx, "scope"] = sc
		DATA[idx, "uid"] = i
		DATA[idx, "type"] = "enum-member"
		NAMES[idx] = i
	}

	unistr_r = gtx_find_results(TREE, "unistr")
	for(n = 0; n < num_children(TREE, unistr_r); n++) {
		delete MAP
		i=gtx_get_map(TREE, MAP, unistr_r, n)
		unistr_uid = MAP["s"]
		if (TREE[unistr_uid, C99F_TYPE] == C99T_UNION)
			ty="union"
		else
			ty="struct"
		nm = safe_name(TREE, i)
		
		if (!(unistr_uid in UNISTR_SEEN)) {
			UNISTR_SEEN[unistr_uid]=1
			sn = safe_name(TREE, unistr_uid)
			sc = scope_str(TREE, unistr_uid)
			if (prnt)
				print ty, unistr_uid, sc, sn > prnt

			if (sc != "")
				idx=sc "." sn
			else
				idx = sn
			DATA[idx, "name"]  = sn
			DATA[idx, "scope"] = sc
			DATA[idx, "uid"] = unistr_uid
			DATA[idx, "type"] = ty
			NAMES[idx] = unistr_uid
		}

		sc = scope_str(TREE, i)
		if (prnt)
			print ty "-member", i,  sc, nm > prnt

		idx=sc "." nm
		DATA[idx, "name"]  = nm
		DATA[idx, "scope"] = sc
		DATA[idx, "uid"] = i
		DATA[idx, "type"] = ty "-member"
		NAMES[idx] = i
	}
}
