/*
    c99tree - input layer, file format dispatcher
    Copyright (C) 2010  Tibor Palinkas

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "tree.h"
#include "tree_load.h"

node_t *tree_load(const char *filename, const char *format)
{
	if (strcmp(format, "c") == 0)
		return tree_load_c(filename);
	if (strcmp(format, "ind") == 0)
		return tree_load_ind(filename);
#ifdef LOAD_XML
	if (strcmp(format, "xml") == 0)
		return tree_load_xml(filename);
#endif
	fprintf(stderr, "Error: unknown input format '%s'\n", format);
	return NULL;
}

node_t *tree_load_cleanup(const char *format)
{
	if (strcmp(format, "c") == 0)
		tree_load_cleanup_c();
/*	if (strcmp(format, "ind") == 0) */
/*	if (strcmp(format, "xml") == 0) */
}

